Subject: Bug#531221: okular: Arbitrarily enforces DRM

From: John Goerzen <[email-masked]>
Date: Mon, 01 Jun 2009 13:07:21 -0500

Ana Guerrero wrote:
> You have got answers from several people from the KDE team and you seemed to 
> stick only to the aggressive ones (i guess because they annoyed you).

Hi Ana,

Thanks for the email.

I don't actually know who is on the KDE team.  But in general, I don't
reply to posts with "I agree" because it just creates noise on the list.
 If there's something I disagree with, then I may post.  So I may be
agreeing with quite a few KDE team members and never know it.

> We all have very different points of view, and we almost never agree on 
> something, and always have to search for some compromise. This time we all 
> agreed on something after a lot of time, this was nice, thanks for this :D

DOH! <grin>

> About this option in okular, call it protection bit, DRM or whatever you want,
> there are  2 options: enabled or disabled. I think this is clear for everybody.

I don't see it that way.  I think there are a multitude of options:

1) Remove the misfeature entirely (as Debian did with xpdf)

2) Change the default so it's disabled

3) Change the alert mechanism so that the user gets a dialog asking if
they want to respect the bit or copy anyway, with a chance to save the
preference for all future sessions

4) Change the text that the user sees to make it clear how to disable
the thing

5) Others, I'm sure.

Some of these are more or less appealing to me; the most appealing to me
are at the top of the list.  You may sort the list differently.

> And you have to choose one. Personally, I think there are good reasons for 
> having it enabled and for having it disabled, like it happens with any setting
> in KDE (in some cases it is more complicated because you do not choose between
> 2 options, more like 10). This is usually just a technical decision, and in KDE 

My personal opinion, as you may gather, is that this is not a feature at
all, but anyhow...

> We tend to respect upstream's defaults, this is important for consistency across 
> distros, and we patch only what is needed for fixing big bugs or integration
> with the Debian system (in the sense of using proper paths for stuff, libraries
> that are somehow different in debian, changes for archs we support, ...).
> I think we are one of the distros that is patching less.

This is an integration bug, in my mind.  As far as I know, none of the
other PDF readers in Debian respect this bit by default.  evince, xpdf,
pdftotext, gs, gv, etc. all ignore it.  KPDF respected it, but without
any information, so I (and apparently several others) switched to evince
or xpdf thinking KPDF sucked because it wouldn't let us copy text from
documents that others would.

> I am sorry, but I am not going to change a default because you think something
> should be differently. I also think that having konsole by default with limited

This bug isn't here because *I* want it different.  I've already
unchecked that box on my machines.  The bug is here because:

1) The behavior is inconsistent with other PDF readers in Debian;

2) The behavior is inconsistent with the liberating ideals of Free Software;

3) The behavior is inconsistent with our social contract;

4) As it stands, it is completely non-obvious that this behavior can be
disabled, or how.

To expand on these each, a bit:

#1: I already discussed above, but I would add that whatever rationale
leads us to remove this misfeature from xpdf should also lead us to
remove it from Okular.

#2: The behavior restricts, by default, ability to manipulate a document
I possess.  Freedom to use my computer to the best of its abilities is
what Free Software is all about.  Restricting my abilities artificially
is opposed to that ideal.

#3: Our social contract states that our priorities are our users and
Free Software.  The users of Debian are not served by an intentionally
crippled PDF reader.

#4: When a program tells you "I can't do something", especially if that
"something" contains the word "DRM", it is not at all natural to go
thinking that the program is a liar and try to find a configuration
option to override it.

Again, I don't care about it for me.  I know about this now and it won't
trip me up again.  But if I ran into this problem, many more people will
to, and not all of them will know how to solve it easily.

Therefore, ideally we should remove this bug.  But if we can't do that,
we should at least make it easy for our users to do so.  I have seen
some proposals on IRC along the lines of suggestions #3 or #4 above to
do just that.

> Finally, today I have seen you quoting in IRC the usual "Our priorities are our 
> users and free software". John, if you are really worried about our users, you 
> should wonder why Debian skip the release 4.2.3 of KDE or if your KDE team needs 
> helps with upcoming 4.3. That will serve all of the users.

I think this is really a low insult.  It feels to me like you are saying
that the work I do for Debian doesn't help our users.  Frankly, I think
it's pretty clear that I do work for Debian that helps our users too; I
maintain quite a number of Haskell libraries and applications, and wrote
a number of libraries and applications from scratch that are part of the
Debian distribution.  Just because my passions and skills lie in an area
apart from KDE development does not mean that I contribute nothing.  I
have neither the time nor the expertise to help with KDE packaging; and
I suspect you have neither the time nor the expertise to help our
understaffed Haskell team.  Let us each contribute where we can the
best, and spare the insults, please.

-- John